/*
 * File struct manipulation.
 */
#include "pmon.h"
#include <strings.h>
#include <sys/types.h>

/*
 *	S I G B I T S
 *
 * Return a string of .'s or X's showing
 *   which signal bits are on.
 */
static
char *
sigbits( value, c )
unsigned int value;
char c;
{
	static char buf[33];
	int	i;

	for( i = 0; i < 32; i++ ) {
		if( value & (1<<i) )
			buf[i] = c;
		else if( ((i+1) % 10) == 0 )
			buf[i] = ',';	/* hash marks every ten */
		else
			buf[i] = '.';
	}

	buf[32] = NULL;
	return (buf);
}

/*
 *	S I G M A S K
 *
 * Return a string of .'s, C's or I's showing
 *   which caught, ignored, or defaulted.
 */
static
char *
sig_mask( catch, ignore, c )
unsigned int catch, ignore;
char c;
{
	static char buf[33];
	int	i;

	for( i = 0; i < 32; i++ ) {
		if( catch & (1<<i) )
			buf[i] = 'C';
		else if( ignore & (1<<i) )
			buf[i] = 'I';
		else
			buf[i] = '.';
	}

	buf[32] = NULL;
	return (buf);
}

dispsigs( x, y )
int x, y;
{
	mvprintw( y, x, "%s", sigbits(pr.p_sig, 'P') );
	mvprintw( y+1, x, "%s", sigbits(pr.p_sigmask, 'B') );
	mvprintw( y+2, x, "%s", sig_mask(pr.p_sigcatch, pr.p_sigignore) );
}
